/**
 * @deprecated - Use `ErrorDetailMap` from `@genesislcap/foundation-utils` instead.
 * @public
 */
export type ErrorDetailMap = Record<string, unknown>;
/**
 * @deprecated - Use `ErrorMapLogger` from `@genesislcap/foundation-utils` instead.
 * @public
 */
export type ErrorMapLogger = (...args: any[]) => void;
/**
 * @deprecated - Use `ErrorMap` from `@genesislcap/foundation-utils` instead.
 * @public
 */
export interface ErrorMap<TErrorDetailMap extends ErrorDetailMap> extends Pick<Map<keyof TErrorDetailMap, Error>, 'get' | 'has' | 'delete' | 'clear' | 'size'> {
    /**
     * Error map as messages.
     * @returns string
     *
     * @public
     */
    readonly messages: string;
    /**
     * Set an error by key.
     * @param key - The key.
     * @param error - The error.
     *
     * @public
     */
    set(key: keyof TErrorDetailMap, error: Error): void;
}
/**
 * A factory to create the error map.
 * @param logger - A logger error method reference.
 * @returns A ErrorMap instance.
 *
 * @deprecated - Use `createErrorMap` from `@genesislcap/foundation-utils` instead.
 * @public
 */
export declare const createErrorMap: <TErrorDetailMap extends ErrorDetailMap>(logger: ErrorMapLogger) => ErrorMap<TErrorDetailMap>;
//# sourceMappingURL=errorMap.d.ts.map