import { __awaiter } from "tslib";
import { DI } from '@microsoft/fast-foundation';
/**
 * @internal
 */
export class DefaultSubService {
    constructor() {
        this.list = () => __awaiter(this, void 0, void 0, function* () {
            if (this.nextResponse instanceof Error) {
                throw this.nextResponse;
            }
            return Promise.resolve(this.nextResponse);
        });
    }
}
/**
 * @internal
 */
export const SubService = DI.createInterface(x => x.singleton(DefaultSubService));
/**
 * @internal
 */
export class DefaultReportService {
    constructor() {
        this.send = (report) => __awaiter(this, void 0, void 0, function* () {
            this.lastSendReport = report;
            if (this.nextResponse instanceof Error) {
                throw this.nextResponse;
            }
            return Promise.resolve(this.nextResponse);
        });
    }
}
/**
 * @internal
 */
export const ReportService = DI.createInterface(x => x.singleton(DefaultReportService));
