## API Report File for "@genesislcap/foundation-store"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import { BindingObserver } from '@microsoft/fast-element';
import { Constructable } from '@microsoft/fast-element';
import { ErrorMap as ErrorMap_2 } from '@genesislcap/foundation-utils';
import type { EventDetailMap } from '@genesislcap/foundation-events';
import { ExecutionContext } from '@microsoft/fast-element';
import { InterfaceSymbol } from '@microsoft/fast-foundation';
import { Key } from '@microsoft/fast-foundation';
import { Observable } from 'rxjs';

// @public
export abstract class AbstractStore<TStore extends Store, TEventDetailMap extends EventDetailMap, TInternalEventDetailMap extends EventDetailMap = TEventDetailMap, TStoreRoot extends StoreRoot = StoreRoot> implements Store {
    constructor(...storeFragments: Store[]);
    // @internal
    protected addEventListeners(element: HTMLElement): void;
    addStoreFragments(...storeFragments: Store[]): void;
    binding<TReturn = any, TParent = any>(token: ((store: this) => TReturn) | keyof this, subscriberChangeCallback?: SubscriberChangeCallback<TReturn> | undefined, isVolatileBinding?: boolean, context?: ExecutionContext): BindingObserver<this, TReturn, TParent>;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "bindingAsRx" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    bindingAsRx(): Observable<this>;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "bindingAsRx" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    bindingAsRx<TKey extends keyof this>(key: TKey): Observable<this[TKey]>;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "bindingAsRx" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    bindingAsRx<TReturn>(getter: (store: this) => TReturn): Observable<TReturn>;
    // @beta
    protected readonly commit: this;
    // @internal
    protected readonly commitHandler: ProxyHandler<this>;
    // @beta
    protected commitValue<K extends keyof TStore>(key: K, value: TStore[K]): void;
    connect(root: TStoreRoot): void;
    // @internal
    protected connectStoreFragments(root: TStoreRoot, storeFragments?: Store[]): void;
    // Warning: (ae-incompatible-release-tags) The symbol "createAsyncListener" is marked as @public, but its signature references "KeyOrKeys" which is marked as @internal
    protected createAsyncListener: <TDetail = void, TReturn = void>(keys: KeyOrKeys<TEventDetailMap & TInternalEventDetailMap>, token: (detail: TDetail, event?: CustomEvent<TDetail>) => Promise<TReturn>) => EventListener;
    // Warning: (ae-incompatible-release-tags) The symbol "createErrorListener" is marked as @public, but its signature references "KeyOrKeys" which is marked as @internal
    protected createErrorListener: <TDetail extends Error = Error>(keys: KeyOrKeys<TEventDetailMap & TInternalEventDetailMap>, token?: (detail: TDetail, event?: CustomEvent<TDetail>) => void) => EventListener;
    // Warning: (ae-incompatible-release-tags) The symbol "createListener" is marked as @public, but its signature references "KeyOrKeys" which is marked as @internal
    protected createListener: <TDetail = void>(keys: KeyOrKeys<TEventDetailMap & TInternalEventDetailMap>, token: (detail: TDetail, event?: CustomEvent<TDetail>) => void) => EventListener;
    disconnect(root: TStoreRoot): void;
    // @internal
    protected disconnectStoreFragments(root: TStoreRoot, storeFragments?: Store[]): void;
    protected emit<K extends keyof (TEventDetailMap & TInternalEventDetailMap) & string>(...args: (TEventDetailMap & TInternalEventDetailMap)[K] extends void ? [key: K] : [key: K, detail: (TEventDetailMap & TInternalEventDetailMap)[K]]): void;
    errors: ErrorMap_2<TEventDetailMap & TInternalEventDetailMap>;
    protected invokeAsyncAPI<TResult>(api: () => Promise<TResult>, error: keyof (TEventDetailMap & TInternalEventDetailMap), success?: keyof (TEventDetailMap & TInternalEventDetailMap)): Promise<void>;
    get name(): string;
    // @internal
    protected removeEventListeners(element: HTMLElement): void;
    removeStoreFragments(...storeFragments: Store[]): void;
    protected root: TStoreRoot;
    // @internal
    protected storeFragments: Store[];
}

// @public
export abstract class AbstractStoreRoot<TStore extends StoreRoot, TEventDetailMap extends StoreRootEventDetailMap = StoreRootEventDetailMap, TInternalEventDetailMap extends EventDetailMap = TEventDetailMap> extends AbstractStore<TStore, TEventDetailMap, TInternalEventDetailMap> implements StoreRoot {
    element: HTMLElement;
    // (undocumented)
    onConnected: EventListener;
    // (undocumented)
    onDisconnected: EventListener;
    // (undocumented)
    onReady: EventListener;
    ready: boolean;
    // (undocumented)
    protected root: this;
}

// @public @deprecated
export const createErrorMap: <TErrorDetailMap extends ErrorDetailMap>(logger: ErrorMapLogger) => ErrorMap<TErrorDetailMap>;

// @public @deprecated (undocumented)
export type ErrorDetailMap = Record<string, unknown>;

// @public @deprecated (undocumented)
export interface ErrorMap<TErrorDetailMap extends ErrorDetailMap> extends Pick<Map<keyof TErrorDetailMap, Error>, 'get' | 'has' | 'delete' | 'clear' | 'size'> {
    readonly messages: string;
    set(key: keyof TErrorDetailMap, error: Error): void;
}

// @public @deprecated (undocumented)
export type ErrorMapLogger = (...args: any[]) => void;

// Warning: (ae-internal-missing-underscore) The name "EventListenerType" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export enum EventListenerType {
    // (undocumented)
    async = "async",
    // (undocumented)
    error = "error",
    // (undocumented)
    sync = "sync"
}

// Warning: (ae-internal-missing-underscore) The name "KeyOrKeys" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export type KeyOrKeys<TEventDetailMaps extends EventDetailMap> = keyof TEventDetailMaps | (keyof TEventDetailMaps)[];

// @public
export const registerStore: <K extends Key>(Base: Constructable<Store>, name?: string) => InterfaceSymbol<K>;

// @public
export interface Store {
    addStoreFragments(...storeFragments: Store[]): void;
    binding<TReturn = any, TParent = any>(token: ((store: this) => TReturn) | keyof this, subscriberChangeCallback?: SubscriberChangeCallback<TReturn> | undefined, isVolatileBinding?: boolean, context?: ExecutionContext): BindingObserver<this, TReturn, TParent>;
    bindingAsRx(): Observable<this>;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "bindingAsRx" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    bindingAsRx<TKey extends keyof this>(key: TKey): Observable<this[TKey]>;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "bindingAsRx" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    bindingAsRx<TReturn>(getter: (store: this) => TReturn): Observable<TReturn>;
    // Warning: (ae-unresolved-inheritdoc-reference) The @inheritDoc reference could not be resolved: The reference is ambiguous because "bindingAsRx" has more than one declaration; you need to add a TSDoc member reference selector
    //
    // (undocumented)
    bindingAsRx<TReturn>(token?: ((store: this) => TReturn) | keyof this): Observable<TReturn | this>;
    readonly errors: ErrorMap_2<EventDetailMap>;
    // @virtual
    readonly name?: string;
    removeStoreFragments(...storeFragments: Store[]): void;
}

// @public (undocumented)
export type StoreBinding<TStore extends Store> = (store: TStore) => any;

// @public
export interface StoreConnectable<TStoreRoot extends StoreRoot> {
    connect(root: TStoreRoot): void;
    disconnect(root: TStoreRoot): void;
}

// @public
export interface StoreRoot extends Store {
    readonly element: HTMLElement;
    // (undocumented)
    onConnected(event: CustomEvent<HTMLElement>): void;
    // (undocumented)
    onDisconnected(event: CustomEvent<void>): void;
    // (undocumented)
    onReady(event: CustomEvent<boolean>): void;
    readonly ready: boolean;
}

// @public
export type StoreRootEventDetailMap = {
    'store-connected': HTMLElement;
    'store-disconnected': void;
    'store-ready': boolean;
};

// @public (undocumented)
export interface StoreSubscriber<TStore extends Store, TReturn = any> {
    // (undocumented)
    handleChange: SubscriberChangeHandler<TStore, TReturn>;
}

// @public (undocumented)
export type SubscriberChangeCallback<TReturn = any> = (value: TReturn, args: BindingObserver) => void;

// @public (undocumented)
export type SubscriberChangeHandler<TStore extends Store, TReturn = any> = (binding: (x?: TStore, context?: ExecutionContext) => TReturn, args: BindingObserver) => void;

// (No @packageDocumentation comment for this package)

```
