<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@genesislcap/foundation-store](./foundation-store.md) &gt; [AbstractStore](./foundation-store.abstractstore.md) &gt; [invokeAsyncAPI](./foundation-store.abstractstore.invokeasyncapi.md)

## AbstractStore.invokeAsyncAPI() method

A convenience method to invoke an async api and emit success and error events.

**Signature:**

```typescript
protected invokeAsyncAPI<TResult>(api: () => Promise<TResult>, error: keyof (TEventDetailMap & TInternalEventDetailMap), success?: keyof (TEventDetailMap & TInternalEventDetailMap)): Promise<void>;
```

## Parameters

|  Parameter | Type | Description |
|  --- | --- | --- |
|  api | () =&gt; Promise&lt;TResult&gt; | The async service api function. |
|  error | keyof (TEventDetailMap &amp; TInternalEventDetailMap) | The event key from the store fragment's event detail map. |
|  success | keyof (TEventDetailMap &amp; TInternalEventDetailMap) | _(Optional)_ The event key from the store fragment's event detail map. |

**Returns:**

Promise&lt;void&gt;

## Remarks

The async api function should throw when it encounters an error.

## Example


```ts
onLoad = this.createAsyncListener('domain-load', async () =>
 this.invokeAsyncAPI(
   async () => {
     !this.domainService.initialized && (await this.domainService.initialize(this.asDomainServiceInit()));
     return this.domainService.list();
   },
   'domain-load-error',
   'domain-load-success'
 )
);
```

